## mingw-w64-qt6-multimedia-6.7.1-1.src.tar.zst

=== config.tests/avfoundation/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from avfoundation.pro.

cmake_minimum_required(VERSION 3.16)
project(config_test_avfoundation LANGUAGES C CXX)

if(DEFINED QT_CONFIG_COMPILE_TEST_CMAKE_SYSTEM_PREFIX_PATH)
    set(CMAKE_SYSTEM_PREFIX_PATH "${QT_CONFIG_COMPILE_TEST_CMAKE_SYSTEM_PREFIX_PATH}")
endif()
if(DEFINED QT_CONFIG_COMPILE_TEST_CMAKE_SYSTEM_FRAMEWORK_PATH)
    set(CMAKE_SYSTEM_FRAMEWORK_PATH "${QT_CONFIG_COMPILE_TEST_CMAKE_SYSTEM_FRAMEWORK_PATH}")
endif()

foreach(p ${QT_CONFIG_COMPILE_TEST_PACKAGES})
    find_package(${p})
endforeach()

if(QT_CONFIG_COMPILE_TEST_LIBRARIES)
    link_libraries(${QT_CONFIG_COMPILE_TEST_LIBRARIES})
endif()
if(QT_CONFIG_COMPILE_TEST_LIBRARY_TARGETS)
    foreach(lib ${QT_CONFIG_COMPILE_TEST_LIBRARY_TARGETS})
        if(TARGET ${lib})
            link_libraries(${lib})
        endif()
    endforeach()
endif()

add_executable(${PROJECT_NAME}
    main.mm
)

=== config.tests/gstreamer_appsrc/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from gstreamer_appsrc.pro.

cmake_minimum_required(VERSION 3.16)
project(config_test_gstreamer_appsrc LANGUAGES C CXX)

if(DEFINED QT_CONFIG_COMPILE_TEST_CMAKE_SYSTEM_PREFIX_PATH)
    set(CMAKE_SYSTEM_PREFIX_PATH "${QT_CONFIG_COMPILE_TEST_CMAKE_SYSTEM_PREFIX_PATH}")
endif()
if(DEFINED QT_CONFIG_COMPILE_TEST_CMAKE_SYSTEM_FRAMEWORK_PATH)
    set(CMAKE_SYSTEM_FRAMEWORK_PATH "${QT_CONFIG_COMPILE_TEST_CMAKE_SYSTEM_FRAMEWORK_PATH}")
endif()

foreach(p ${QT_CONFIG_COMPILE_TEST_PACKAGES})
    find_package(${p})
endforeach()

if(QT_CONFIG_COMPILE_TEST_LIBRARIES)
    link_libraries(${QT_CONFIG_COMPILE_TEST_LIBRARIES})
endif()
if(QT_CONFIG_COMPILE_TEST_LIBRARY_TARGETS)
    foreach(lib ${QT_CONFIG_COMPILE_TEST_LIBRARY_TARGETS})
        if(TARGET ${lib})
            link_libraries(${lib})
        endif()
    endforeach()
endif()

add_executable(${PROJECT_NAME}
    main.cpp
)

=== tests/auto/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from auto.pro.

add_subdirectory(unit)
add_subdirectory(integration)
# special case begin
# add_subdirectory(cmake)
# special case end

=== tests/manual/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

add_subdirectory(audiodecoder)
add_subdirectory(devices)
add_subdirectory(minimal-player)
add_subdirectory(wasm)

if(TARGET Qt::Quick)
    add_subdirectory(qml-minimal-camera)
    add_subdirectory(qml-minimal-player)

    if (QT_FEATURE_gstreamer)
        add_subdirectory(qml-gstreamer-rtp)
    endif()
endif()

=== examples/multimedia/audiosource/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(audiosource LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/multimedia/audiosource")

find_package(Qt6 REQUIRED COMPONENTS Core Gui Multimedia Widgets)

qt_add_executable(audiosource
    audiosource.cpp audiosource.h
    main.cpp
)

set_target_properties(audiosource PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
    MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in
)

target_include_directories(audiosource PUBLIC
    ../shared
)

target_link_libraries(audiosource PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Multimedia
    Qt::Widgets
)

install(TARGETS audiosource
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== tests/manual/minimal-player/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(sidepanel LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/multimedia/minimal-player")

find_package(Qt6 REQUIRED COMPONENTS Widgets Multimedia MultimediaWidgets)

qt_add_executable( minimal-player WIN32 MACOSX_BUNDLE
    minimal-player.cpp
)

target_link_libraries( minimal-player PUBLIC
    Qt::Widgets
    Qt::Multimedia
    Qt::MultimediaWidgets
)

install(TARGETS  minimal-player
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

set_target_properties( minimal-player PROPERTIES
    MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in
)

=== src/plugins/multimedia/gstreamer/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_find_package(EGL)

qt_internal_add_module(QGstreamerMediaPluginPrivate
    STATIC
    INTERNAL_MODULE
    SOURCES
        audio/qgstreameraudiodevice.cpp audio/qgstreameraudiodevice_p.h
        audio/qgstreameraudiosource.cpp audio/qgstreameraudiosource_p.h
        audio/qgstreameraudiosink.cpp audio/qgstreameraudiosink_p.h
        audio/qgstreameraudiodecoder.cpp audio/qgstreameraudiodecoder_p.h
        common/qglist_helper_p.h
        common/qgst.cpp common/qgst_p.h
        common/qgst_debug.cpp common/qgst_debug_p.h
        common/qgst_handle_types_p.h
        common/qgstappsource.cpp common/qgstappsource_p.h
        common/qgstreameraudioinput.cpp common/qgstreameraudioinput_p.h
        common/qgstreameraudiooutput.cpp common/qgstreameraudiooutput_p.h
        common/qgstreamerbufferprobe.cpp common/qgstreamerbufferprobe_p.h
        common/qgstreamermetadata.cpp common/qgstreamermetadata_p.h
        common/qgstreamermessage_p.h
        common/qgstreamermediaplayer.cpp common/qgstreamermediaplayer_p.h
        common/qgstreamervideooutput.cpp common/qgstreamervideooutput_p.h
        common/qgstreamervideooverlay.cpp common/qgstreamervideooverlay_p.h
        common/qgstreamervideosink.cpp common/qgstreamervideosink_p.h
        common/qgstpipeline.cpp common/qgstpipeline_p.h
        common/qgstutils.cpp common/qgstutils_p.h
        common/qgstvideobuffer.cpp common/qgstvideobuffer_p.h
        common/qgstvideorenderersink.cpp common/qgstvideorenderersink_p.h
        common/qgstsubtitlesink.cpp common/qgstsubtitlesink_p.h
        qgstreamerintegration.cpp qgstreamerintegration_p.h
        qgstreamerformatinfo.cpp qgstreamerformatinfo_p.h
        qgstreamervideodevices.cpp qgstreamervideodevices_p.h
        mediacapture/qgstreamercamera.cpp mediacapture/qgstreamercamera_p.h
        mediacapture/qgstreamerimagecapture.cpp mediacapture/qgstreamerimagecapture_p.h
        mediacapture/qgstreamermediacapture.cpp mediacapture/qgstreamermediacapture_p.h
        mediacapture/qgstreamermediaencoder.cpp mediacapture/qgstreamermediaencoder_p.h
    NO_UNITY_BUILD_SOURCES
        # Conflicts with macros defined in X11.h, and Xlib.h
        common/qgstvideobuffer.cpp
        common/qgstreamervideosink.cpp
    NO_GENERATE_CPP_EXPORTS
    DEFINES
        GLIB_VERSION_MIN_REQUIRED=GLIB_VERSION_2_26
    PUBLIC_LIBRARIES
        Qt::MultimediaPrivate
        Qt::CorePrivate
        GStreamer::GStreamer
        GStreamer::App
)

qt_internal_extend_target(QGstreamerMediaPluginPrivate CONDITION QT_FEATURE_gstreamer_photography
    LIBRARIES
        GStreamer::Photography
)

qt_internal_extend_target(QGstreamerMediaPluginPrivate CONDITION QT_FEATURE_gstreamer_gl
    LIBRARIES
        GStreamer::Gl
        EGL::EGL
)

qt_internal_add_plugin(QGstreamerMediaPlugin
    OUTPUT_NAME gstreamermediaplugin
    PLUGIN_TYPE multimedia
    SOURCES
        qgstreamerplugin.cpp
        gstreamer.json
    LIBRARIES
        Qt::QGstreamerMediaPluginPrivate
        Qt::MultimediaPrivate
)

=== src/plugins/multimedia/qnx/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause


qt_internal_add_plugin(QQnxMediaPlugin
    OUTPUT_NAME qnxmediaplugin
    PLUGIN_TYPE multimedia
    SOURCES
        camera/qqnxcamera.cpp camera/qqnxcamera_p.h
        camera/qqnxplatformcamera.cpp camera/qqnxplatformcamera_p.h
        camera/qqnxcameraframebuffer.cpp camera/qqnxcameraframebuffer_p.h
        camera/qqnximagecapture.cpp camera/qqnximagecapture_p.h
        common/qqnxaudioinput.cpp common/qqnxaudioinput_p.h
        common/qqnxaudiooutput.cpp common/qqnxaudiooutput_p.h
        common/qqnxmediaeventthread.cpp common/qqnxmediaeventthread_p.h
        common/qqnxwindowgrabber.cpp common/qqnxwindowgrabber_p.h
        capture/qqnxaudiorecorder.cpp capture/qqnxaudiorecorder_p.h
        capture/qqnxmediacapturesession.cpp capture/qqnxmediacapturesession_p.h
        capture/qqnxmediarecorder.cpp capture/qqnxmediarecorder_p.h
        mediaplayer/qqnxmediaplayer.cpp mediaplayer/qqnxmediaplayer_p.h
        mediaplayer/qqnxmediametadata.cpp mediaplayer/qqnxmediametadata_p.h
        mediaplayer/qqnxvideosink.cpp mediaplayer/qqnxvideosink_p.h
        mediaplayer/qqnxmediautil.cpp mediaplayer/qqnxmediautil_p.h
        qqnxformatinfo.cpp qqnxformatinfo_p.h
        qqnxmediaintegration.cpp qqnxmediaintegration_p.h
        qqnxvideodevices.cpp qqnxvideodevices_p.h
    INCLUDE_DIRECTORIES
        audio
        camera
        capture
        common
        mediaplayer
    LIBRARIES
        Qt::MultimediaPrivate
        Qt::CorePrivate
        MMRenderer::MMRenderer
        strm
        camapi
)

=== tests/auto/integration/qaudiosink/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qaudiosink Test:
#####################################################################

qt_internal_add_test(tst_qaudiosink
    SOURCES
        tst_qaudiosink.cpp
    LIBRARIES
        Qt::Gui
        Qt::MultimediaPrivate
)

=== tests/auto/integration/qcamerabackend/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qcamerabackend.pro.

#####################################################################
## tst_qcamerabackend Test:
#####################################################################

qt_internal_add_test(tst_qcamerabackend
    SOURCES
        tst_qcamerabackend.cpp
        ../shared/mediabackendutils.h
    INCLUDE_DIRECTORIES
        ../shared/
    LIBRARIES
        Qt::Gui
        Qt::MultimediaPrivate
        Qt::Widgets
)

# special case begin
if (APPLE)
    set_property(TARGET tst_qcamerabackend PROPERTY MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/Info.plist")
    set_property(TARGET tst_qcamerabackend PROPERTY PROPERTY MACOSX_BUNDLE TRUE)
endif()
# special case end

=== tests/auto/integration/qml/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qml.pro.

#####################################################################
## tst_qml Test:
#####################################################################

qt_internal_add_test(tst_qml
    GUI
    QMLTEST
    SOURCES
        tst_qml.cpp
    LIBRARIES
        Qt::Gui
)

#### Keys ignored in scope 1:.:.:qml.pro:<TRUE>:
# DEPLOYMENT = "importFiles"
# TEMPLATE = "app"
# importFiles.files = "soundeffect"
# importFiles.path = "."

=== tests/auto/integration/qvideoframebackend/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qvideoframebackend Test:
#####################################################################

# Collect test data
file(GLOB_RECURSE test_data_glob
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    testdata/*)
list(APPEND testdata_resource_files ${test_data_glob})

qt_internal_add_test(tst_qvideoframebackend
    SOURCES
        ../shared/mediafileselector.h
        ../shared/testvideosink.h
        tst_qvideoframebackend.cpp
    LIBRARIES
        Qt::Gui
        Qt::MultimediaPrivate
    TESTDATA ${testdata_resource_files}
    INCLUDE_DIRECTORIES
        ../shared/
)

qt_internal_add_resource(tst_qvideoframebackend "testdata"
    PREFIX
        "/"
    FILES
        ${testdata_resource_files}
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-multimedia
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-wmf")
_qtver=6.7.1
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Classes for audio, video, radio and camera functionality (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtmultimedia.git"
msys2_references=(
  'archlinux: qt6-multimedia'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             #"${MINGW_PACKAGE_PREFIX}-pulseaudio"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz"
        001-export-some-constexpr-variables.patch)
sha256sums=('656d1543727f5bf1bd39fe2548ac454860109dc8555df77d7940f21e3d65cd3e'
            'e1694338779eb499341618c62d11f832f2b7f1f90c8a20345932530a61203105')

prepare() {
  cd "${srcdir}"/${_pkgfn}
  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    patch -p1 -i "${srcdir}"/001-export-some-constexpr-variables.patch
  fi
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DFEATURE_wmf=ON \
    -DFEATURE_gstreamer=OFF \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-multimedia() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
           "${MINGW_PACKAGE_PREFIX}-qt6-multimedia-ffmpeg")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative"
              "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
              "${MINGW_PACKAGE_PREFIX}-qt6-multimedia-wmf")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs ${pkgdir}/.${MINGW_PREFIX} ${srcdir}/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}

  # Split plugins
  rm -r "${pkgdir}${MINGW_PREFIX}/share/qt6/plugins"
  rm "${pkgdir}${MINGW_PREFIX}"/lib/cmake/Qt6Multimedia/Qt6Q{FFmpeg,Windows}MediaPlugin*
}

package_qt6-multimedia-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf ${srcdir}/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

package_qt6-multimedia-ffmpeg() {
  pkgdesc='FFMpeg backend for qt6-multimedia'
  depends=("${MINGW_PACKAGE_PREFIX}-ffmpeg"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")

  DESTDIR="$pkgdir" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}/src/plugins/multimedia/ffmpeg

  find "${pkgdir}${MINGW_PREFIX}" -type f -name '*.debug' -delete
}

package_qt6-multimedia-wmf() {
  pkgdesc='Windows Media Foundation backend for qt6-multimedia'
  depends=("${MINGW_PACKAGE_PREFIX}-${_realname}")

  DESTDIR="$pkgdir" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}/src/plugins/multimedia/windows

  find "${pkgdir}${MINGW_PREFIX}" -type f -name '*.debug' -delete
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
